Index: trunk/source/Lib/TLibDecoder/TDecSbac.cpp
===================================================================
--- trunk/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 443)
+++ trunk/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 608)
@@ -613,38 +750,18 @@
   DTRACE_CABAC_V( uiSymbol );
   DTRACE_CABAC_T( "\n");
+#endif
   
   if( uiSymbol )
   {
-    pcCU->setPredModeSubParts( MODE_SKIP,  uiAbsPartIdx, uiDepth );
+    pcCU->setSkipFlagSubParts( true,        uiAbsPartIdx, uiDepth );
+    pcCU->setPredModeSubParts( MODE_INTER,  uiAbsPartIdx, uiDepth );
     pcCU->setPartSizeSubParts( SIZE_2Nx2N, uiAbsPartIdx, uiDepth );
     pcCU->setSizeSubParts( g_uiMaxCUWidth>>uiDepth, g_uiMaxCUHeight>>uiDepth, uiAbsPartIdx, uiDepth );
     pcCU->setMergeFlagSubParts( true , uiAbsPartIdx, 0, uiDepth );
   }
-}
-
-#if LGE_ILLUCOMP_B0045
-/** parse illumination compensation flag
- * \param pcCU
- * \param uiAbsPartIdx 
- * \param uiDepth
- * \returns Void
- */
-Void TDecSbac::parseICFlag( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
-{ 
-  UInt uiSymbol = 0;
-  UInt uiCtxIC = pcCU->getCtxICFlag( uiAbsPartIdx );
-  m_pcTDecBinIf->decodeBin( uiSymbol, m_cCUICFlagSCModel.get( 0, 0, uiCtxIC ) );
-  DTRACE_CABAC_VL( g_nSymbolCounter++ );
-  DTRACE_CABAC_T( "\tICFlag" );
-  DTRACE_CABAC_T( "\tuiCtxIC: ");
-  DTRACE_CABAC_V( uiCtxIC );
-  DTRACE_CABAC_T( "\tuiSymbol: ");
-  DTRACE_CABAC_V( uiSymbol );
-  DTRACE_CABAC_T( "\n");
-  
-  pcCU->setICFlagSubParts( uiSymbol ? true : false , uiAbsPartIdx, 0, uiDepth );
-}
-#endif
-
+#if H_MV_ENC_DEC_TRAC
+  DTRACE_CU("cu_skip_flag", uiSymbol); 
+#endif
+}
 
 /** parse merge flag
@@ -659,6 +776,10 @@
   UInt uiSymbol;
   m_pcTDecBinIf->decodeBin( uiSymbol, *m_cCUMergeFlagExtSCModel.get( 0 ) );
+#if H_MV_ENC_DEC_TRAC
+  DTRACE_PU("merge_flag", uiSymbol)
+#endif
   pcCU->setMergeFlagSubParts( uiSymbol ? true : false, uiAbsPartIdx, uiPUIdx, uiDepth );
 
+#if !H_MV_ENC_DEC_TRAC
   DTRACE_CABAC_VL( g_nSymbolCounter++ );
   DTRACE_CABAC_T( "\tMergeFlag: " );
@@ -669,15 +790,11 @@
   DTRACE_CABAC_V( uiAbsPartIdx );
   DTRACE_CABAC_T( "\n" );
-}
-
-Void TDecSbac::parseMergeIndex ( TComDataCU* pcCU, UInt& ruiMergeIndex, UInt uiAbsPartIdx, UInt uiDepth )
-{
-  UInt uiNumCand = MRG_MAX_NUM_CANDS;
+#endif
+}
+
+Void TDecSbac::parseMergeIndex ( TComDataCU* pcCU, UInt& ruiMergeIndex )
+{
   UInt uiUnaryIdx = 0;
-  uiNumCand = pcCU->getSlice()->getMaxNumMergeCand();
-#if HHI_MPI
-  const Bool bMVIAvailable = pcCU->getSlice()->getSPS()->getUseMVI() && pcCU->getSlice()->getSliceType() != I_SLICE;
-  const UInt uiMviMergePos = bMVIAvailable ? HHI_MPI_MERGE_POS : uiNumCand;
-#endif
+  UInt uiNumCand = pcCU->getSlice()->getMaxNumMergeCand();
   if ( uiNumCand > 1 )
   {
@@ -698,7 +815,11 @@
       }
     }
+#if H_MV_ENC_DEC_TRAC
+    DTRACE_PU("merge_idx", uiUnaryIdx)
+#endif
   }
   ruiMergeIndex = uiUnaryIdx;
 
+#if !H_MV_ENC_DEC_TRAC
   DTRACE_CABAC_VL( g_nSymbolCounter++ )
   DTRACE_CABAC_T( "\tparseMergeIndex()" )
@@ -706,37 +827,7 @@
   DTRACE_CABAC_V( ruiMergeIndex )
   DTRACE_CABAC_T( "\n" )
-#if HHI_MPI
-  if( ruiMergeIndex > uiMviMergePos )
-  {
-    assert( bMVIAvailable );
-    ruiMergeIndex--;
-  }
-  else if( ruiMergeIndex == uiMviMergePos )
-  {
-    assert( bMVIAvailable );
-    pcCU->setTextureModeDepthSubParts( uiDepth, uiAbsPartIdx, uiDepth );
-  }
-#endif
-}
-
-#if H3D_IVRP
-Void
-TDecSbac::parseResPredFlag( TComDataCU* pcCU, Bool& rbResPredFlag, UInt uiAbsPartIdx, UInt uiDepth )
-{
-  UInt uiCtx    = pcCU->getCtxResPredFlag( uiAbsPartIdx );
-  UInt uiSymbol = 0;
-  m_pcTDecBinIf->decodeBin( uiSymbol, m_cResPredFlagSCModel.get( 0, 0, uiCtx ) );
-  rbResPredFlag = ( uiSymbol != 0 );
-}
-#endif
-
-#if H3D_IVMP
-Void TDecSbac::parseMVPIdx      ( Int& riMVPIdx, Int iNumAMVPCands )
-{
-  UInt uiSymbol;
-  xReadUnaryMaxSymbol(uiSymbol, m_cMVPIdxSCModel.get(0), 1, iNumAMVPCands-1);
-  riMVPIdx = uiSymbol;
-}
-#else
+#endif
+}
+
 Void TDecSbac::parseMVPIdx      ( Int& riMVPIdx )
 {
@@ -745,5 +836,4 @@
   riMVPIdx = uiSymbol;
 }
-#endif
 
 Void TDecSbac::parseSplitFlag     ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
@@ -754,8 +844,7 @@
     return;
   }
-  
+
   UInt uiSymbol;
-
-#if H3D_QTL
+#if H_3D_QTLPC
   Bool bParseSplitFlag    = true;
 
@@ -765,6 +854,7 @@
   Bool bIntraSliceDetect  = (pcCU->getSlice()->getSliceType() == I_SLICE);
 
-  Bool rapPic     = (pcCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR || pcCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_CRA);
-  if(bDepthMapDetect && !bIntraSliceDetect && !rapPic && sps->getUseQTLPC())
+  Bool rapPic = (pcCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR_W_RADL || pcCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR_N_LP || pcCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_CRA);
+
+  if(bDepthMapDetect && !bIntraSliceDetect && !rapPic && sps->getUseQTL() && sps->getUsePC())
   {
     TComDataCU *pcTextureCU = pcTexture->getCU(pcCU->getAddr());
@@ -777,12 +867,17 @@
 #endif
     m_pcTDecBinIf->decodeBin( uiSymbol, m_cCUSplitFlagSCModel.get( 0, 0, pcCU->getCtxSplitFlag( uiAbsPartIdx, uiDepth ) ) );
+#if H_MV_ENC_DEC_TRAC
+    DTRACE_CU("split_cu_flag", uiSymbol); 
+#else
     DTRACE_CABAC_VL( g_nSymbolCounter++ )
     DTRACE_CABAC_T( "\tSplitFlag\n" )
-#if H3D_QTL
+#endif
+#if H_3D_QTLPC
   }
   else
+  {
     uiSymbol = 0;
-#endif
-
+  }
+#endif
   pcCU->setDepthSubParts( uiDepth + uiSymbol, uiAbsPartIdx );
   
@@ -801,5 +896,5 @@
   PartSize eMode;
 
-#if H3D_QTL
+#if H_3D_QTLPC
   Bool bParsePartSize    = true;
   TComSPS *sps           = pcCU->getPic()->getSlice(0)->getSPS();
@@ -808,6 +903,7 @@
   Bool bIntraSliceDetect = (pcCU->getSlice()->getSliceType() == I_SLICE);
 
-  Bool rapPic     = (pcCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR || pcCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_CRA);
-  if(bDepthMapDetect && !bIntraSliceDetect && !rapPic && sps->getUseQTLPC())
+  Bool rapPic     = (pcCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR_W_RADL || pcCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR_N_LP || pcCU->getSlice()->getNalUnitType() == NAL_UNIT_CODED_SLICE_CRA);
+
+  if(bDepthMapDetect && !bIntraSliceDetect && !rapPic && sps->getUseQTL() && sps->getUsePC())
   {
     TComDataCU *pcTextureCU = pcTexture->getCU(pcCU->getAddr());
@@ -820,18 +916,22 @@
   }
 #endif
+
   
   if ( pcCU->isIntra( uiAbsPartIdx ) )
   {
-#if H3D_QTL
+#if H_3D_QTLPC
     if(bParsePartSize)
     {
 #endif
-      uiSymbol = 1;
+     uiSymbol = 1;
       if( uiDepth == g_uiMaxCUDepth - g_uiAddCUDepth )
       {
         m_pcTDecBinIf->decodeBin( uiSymbol, m_cCUPartSizeSCModel.get( 0, 0, 0) );
+#if H_MV_ENC_DEC_TRAC          
+        DTRACE_CU("part_mode", uiSymbol)
+#endif        
       }
       eMode = uiSymbol ? SIZE_2Nx2N : SIZE_NxN;
-#if H3D_QTL
+#if H_3D_QTLPC
     }
 #endif
@@ -851,10 +951,10 @@
   else
   {
-#if H3D_QTL
+#if H_3D_QTLPC
     if(bParsePartSize)
     {
 #endif
       UInt uiMaxNumBits = 2;
-      if( uiDepth == g_uiMaxCUDepth - g_uiAddCUDepth && !( pcCU->getSlice()->getSPS()->getDisInter4x4() && (g_uiMaxCUWidth>>uiDepth) == 8 && (g_uiMaxCUHeight>>uiDepth) == 8 ) )
+      if( uiDepth == g_uiMaxCUDepth - g_uiAddCUDepth && !( (g_uiMaxCUWidth>>uiDepth) == 8 && (g_uiMaxCUHeight>>uiDepth) == 8 ) )
       {
         uiMaxNumBits ++;
@@ -874,5 +974,5 @@
         if (eMode == SIZE_2NxN)
         {
-            m_pcTDecBinIf->decodeBin(uiSymbol, m_cCUAMPSCModel.get( 0, 0, 0 ));
+          m_pcTDecBinIf->decodeBin(uiSymbol, m_cCUAMPSCModel.get( 0, 0, 0 ));
           if (uiSymbol == 0)
           {
@@ -891,5 +991,8 @@
         }
       }
-#if H3D_QTL
+#if H_MV_ENC_DEC_TRAC          
+      DTRACE_CU("part_mode", eMode )
+#endif
+#if H_3D_QTLPC
     }
 #endif
@@ -917,399 +1020,102 @@
   m_pcTDecBinIf->decodeBin( uiSymbol, m_cCUPredModeSCModel.get( 0, 0, 0 ) );
   iPredMode += uiSymbol;
+#if H_MV_ENC_DEC_TRAC          
+  DTRACE_CU("pred_mode_flag", uiSymbol)
+#endif        
   pcCU->setPredModeSubParts( (PredMode)iPredMode, uiAbsPartIdx, uiDepth );
 }
-#if PKU_QC_DEPTH_INTRA_UNI_D0195
-Void TDecSbac::parseDepthIntraMode  ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
-{
-  UInt uiPuIdx = ( pcCU->getWidth(uiAbsPartIdx) == 64 )? 2 : ( ( pcCU->getPartitionSize(uiAbsPartIdx) == SIZE_NxN && pcCU->getWidth(uiAbsPartIdx) == 8 )? 0 : 1);
-  UInt uiDir = 0;
-  Bool bSDCFlag = 0;
-  UInt uiSymbol = 1;
-  UInt uiCode = 0 ;
-  UInt uiBinNum = 0;
-  UInt uiCtxDepthMode = 0;
-  if ( uiPuIdx ==2 )
-  {
-    while(uiBinNum<2 && uiSymbol)
-    {
-      uiCtxDepthMode = uiPuIdx*3 + uiBinNum;
-      m_pcTDecBinIf->decodeBin(uiSymbol,m_cDepthModeModel.get(0,0,uiCtxDepthMode));
-      uiCode = (uiCode<<1)+uiSymbol;
-      uiBinNum++;
-    }
-    if (uiCode == 0)      { uiDir = PLANAR_IDX; bSDCFlag = 1;}
-    else if (uiCode == 2) { uiDir = 0;          bSDCFlag = 0;}
-    else if (uiCode == 3) { uiDir = DC_IDX;     bSDCFlag = 1;}
-  }
-  else if ( uiPuIdx ==0 )
-  {
-    while(uiBinNum<3 && uiSymbol)
-    {
-      uiCtxDepthMode = uiPuIdx*3 + ( uiBinNum >= 2? 2 : uiBinNum );
-      m_pcTDecBinIf->decodeBin(uiSymbol,m_cDepthModeModel.get(0,0,uiCtxDepthMode));
-      uiCode = (uiCode<<1)+uiSymbol;
-      uiBinNum++;
-    }
-    if (uiCode == 0)      { uiDir = 0;                     bSDCFlag = 0;}
-    else if (uiCode == 2) { uiDir = DMM_WEDGE_FULL_IDX;    bSDCFlag = 0;}
-    else if (uiCode == 6) { uiDir = DMM_WEDGE_PREDTEX_IDX; bSDCFlag = 0;}
-    else if (uiCode == 7) { uiDir = EDGE_INTRA_IDX;        bSDCFlag = 0;}
-  }
-  else
-  {
-    uiCtxDepthMode = uiPuIdx*3 ;
-    m_pcTDecBinIf->decodeBin(uiSymbol,m_cDepthModeModel.get(0,0,uiCtxDepthMode));
-    uiCode = (uiCode<<1)+uiSymbol;
-    if (!uiSymbol)
-    {
-      uiCtxDepthMode = uiPuIdx*3 + 1;
-      m_pcTDecBinIf->decodeBin(uiSymbol,m_cDepthModeModel.get(0,0,uiCtxDepthMode));
-      uiCode = (uiCode<<1)+uiSymbol;
-      if (uiSymbol) 
+
+Void TDecSbac::parseIntraDirLumaAng  ( TComDataCU* pcCU, UInt absPartIdx, UInt depth )
+{
+  PartSize mode = pcCU->getPartitionSize( absPartIdx );
+  UInt partNum = mode==SIZE_NxN?4:1;
+  UInt partOffset = ( pcCU->getPic()->getNumPartInCU() >> ( pcCU->getDepth(absPartIdx) << 1 ) ) >> 2;
+  UInt mpmPred[4],symbol;
+  Int j,intraPredMode;    
+  if (mode==SIZE_NxN)
+  {
+    depth++;
+  }
+  for (j=0;j<partNum;j++)
+  {
+#if H_3D_DIM
+    if( pcCU->getSlice()->getVpsDepthModesFlag() )
+    {
+      parseIntraDepth( pcCU, absPartIdx+partOffset*j, depth );
+    }
+    if( pcCU->getLumaIntraDir( absPartIdx+partOffset*j ) < NUM_INTRA_MODE )
+#if H_3D_DIM_SDC
+      if( !pcCU->getSDCFlag( absPartIdx+partOffset*j ) )
+#endif
+    {
+#endif
+    m_pcTDecBinIf->decodeBin( symbol, m_cCUIntraPredSCModel.get( 0, 0, 0) );
+    mpmPred[j] = symbol;
+#if H_MV_ENC_DEC_TRAC          
+    DTRACE_CU("prev_intra_luma_pred_flag", symbol)
+#endif
+#if H_3D_DIM
+    }
+#endif
+  }
+  for (j=0;j<partNum;j++)
+  {
+#if H_3D_DIM
+    if( pcCU->getLumaIntraDir( absPartIdx+partOffset*j ) < NUM_INTRA_MODE )
+#if H_3D_DIM_SDC
+      if( !pcCU->getSDCFlag( absPartIdx+partOffset*j ) )
+#endif
+    {
+#endif
+    Int preds[3] = {-1, -1, -1};
+    Int predNum = pcCU->getIntraDirLumaPredictor(absPartIdx+partOffset*j, preds);  
+    if (mpmPred[j])
+    {
+      m_pcTDecBinIf->decodeBinEP( symbol );
+      if (symbol)
+      {
+        m_pcTDecBinIf->decodeBinEP( symbol );
+        symbol++;
+      }
+#if H_MV_ENC_DEC_TRAC          
+      DTRACE_CU("mpm_idx", symbol)
+#endif
+      intraPredMode = preds[symbol];
+    }
+    else
+    {
+      m_pcTDecBinIf->decodeBinsEP( symbol, 5 );
+      intraPredMode = symbol;
+#if H_MV_ENC_DEC_TRAC          
+      DTRACE_CU("rem_intra_luma_pred_mode", symbol)
+#endif        
+      //postponed sorting of MPMs (only in remaining branch)
+      if (preds[0] > preds[1])
       { 
-        uiCtxDepthMode = uiPuIdx*3 + 2;
-        m_pcTDecBinIf->decodeBin(uiSymbol,m_cDepthModeModel.get(0,0,uiCtxDepthMode));
-        uiCode = (uiCode<<1)+uiSymbol;
-      }
-    }
-    else
-    {
-      uiCtxDepthMode = uiPuIdx*3 + 1;
-      m_pcTDecBinIf->decodeBin(uiSymbol,m_cDepthModeModel.get(0,0,uiCtxDepthMode));
-      uiCode = (uiCode<<1)+uiSymbol;
-      if (!uiSymbol) 
-      { 
-        uiCtxDepthMode = uiPuIdx*3 + 2;
-        m_pcTDecBinIf->decodeBin(uiSymbol,m_cDepthModeModel.get(0,0,uiCtxDepthMode));
-        uiCode = (uiCode<<1)+uiSymbol;
-      }
-      else
-      {
-        uiBinNum = 0;
-        while( uiSymbol && uiBinNum<3 )
-        {
-          uiCtxDepthMode = uiPuIdx*3 + 2;
-          m_pcTDecBinIf->decodeBin(uiSymbol,m_cDepthModeModel.get(0,0,uiCtxDepthMode));
-          uiCode = (uiCode<<1)+uiSymbol;
-          uiBinNum++;
-        }
-      }
-    }
-    if (uiCode == 0)       { uiDir = PLANAR_IDX;              bSDCFlag = 1;}
-    else if (uiCode == 2)  { uiDir = 5;                       bSDCFlag = 0;}
-    else if (uiCode == 3)  { uiDir = DMM_WEDGE_FULL_IDX;      bSDCFlag = 1;}
-    else if (uiCode == 4)  { uiDir = DMM_WEDGE_FULL_IDX;      bSDCFlag = 0;}
-    else if (uiCode == 5)  { uiDir = DMM_CONTOUR_PREDTEX_IDX; bSDCFlag = 0;}
-    else if (uiCode == 6)  { uiDir = DMM_WEDGE_PREDTEX_IDX;   bSDCFlag = 0;}
-    else if (uiCode == 14) { uiDir = DC_IDX;                  bSDCFlag = 1;}
-    else if (uiCode == 31) { uiDir = DMM_WEDGE_PREDDIR_IDX;   bSDCFlag = 0;}
-    else if (uiCode == 30) { uiDir = EDGE_INTRA_IDX;          bSDCFlag = 0;}
-  }
-  pcCU->setLumaIntraDirSubParts( (UChar)uiDir, uiAbsPartIdx, uiDepth );
-  pcCU->setSDCFlagSubParts(bSDCFlag, uiAbsPartIdx, 0, uiDepth); 
-}
-Void TDecSbac::parseDepthModelingTable  ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
-{
-  parseDepthIntraMode(pcCU,uiAbsPartIdx,uiDepth);
-  
-  UInt uiDir = pcCU->getLumaIntraDir(uiAbsPartIdx);
-  Bool bSdcFlag =  pcCU->getSDCAvailable(uiAbsPartIdx) && pcCU->getSDCFlag(uiAbsPartIdx);
-  Bool bDmmFlag = (uiDir >= NUM_INTRA_MODE && uiDir < EDGE_INTRA_IDX &&(!bSdcFlag))? 1:0;
-  if (uiDir >= NUM_INTRA_MODE && uiDir < EDGE_INTRA_IDX)//DMM modes and SDC DMM1
-  {
-    if( uiDir == DMM_WEDGE_FULL_IDX )          { xParseWedgeFullInfo          ( pcCU, uiAbsPartIdx, uiDepth ); }
-    else if( uiDir == DMM_WEDGE_PREDTEX_IDX )  { xParseWedgePredTexInfo       ( pcCU, uiAbsPartIdx, uiDepth ); }
-    else if( uiDir == DMM_WEDGE_PREDDIR_IDX )  { xParseWedgePredDirInfo       ( pcCU, uiAbsPartIdx, uiDepth ); }
-  } 
-  else if(uiDir >= EDGE_INTRA_IDX)//CCM mode
-  {
-    xParseEdgeIntraInfo( pcCU, uiAbsPartIdx, uiDepth );
-  }
-  
+        std::swap(preds[0], preds[1]); 
+      }
+      if (preds[0] > preds[2])
+      {
+        std::swap(preds[0], preds[2]);
+      }
+      if (preds[1] > preds[2])
+      {
+        std::swap(preds[1], preds[2]);
+      }
+      for ( Int i = 0; i < predNum; i++ )
+      {
+        intraPredMode += ( intraPredMode >= preds[i] );
+      }
+    }
+    pcCU->setLumaIntraDirSubParts( (UChar)intraPredMode, absPartIdx+partOffset*j, depth );
+#if H_3D_DIM
+    }
+#endif
+  }
+}
+
+Void TDecSbac::parseIntraDirChroma( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
+{
   UInt uiSymbol;
-  if (bDmmFlag)
-  {
-    if (bDmmFlag)
-    {
-      m_pcTDecBinIf->decodeBin( uiSymbol , m_cDmmDeltaFlagModel.get(0, 0, 0) );
-      uiDir += uiSymbol;
-    }
-    if (uiSymbol)
-    {
-      UInt uiDC;
-      Int iDC = 0,iDC1 = 0,iDC2 = 0;
-      for ( Int i = 0; i  <2; i++ )
-      {
-        xReadExGolombLevel( uiDC, m_cDmmDataSCModel.get(0, 0, 1) );
-        iDC = uiDC;
-        if ( uiDC )
-        {
-          UInt uiSign;
-          m_pcTDecBinIf->decodeBinEP( uiSign );
-          if ( uiSign )
-          {
-            iDC = -iDC;
-          }
-        }
-        if ( i == 0 ) { iDC1 = iDC; }
-        else          { iDC2 = iDC; }
-      }
-
-      if( uiDir == DMM_WEDGE_FULL_D_IDX )   
-      { 
-        pcCU->setWedgeFullDeltaDC1SubParts( iDC1, uiAbsPartIdx, uiDepth );
-        pcCU->setWedgeFullDeltaDC2SubParts( iDC2, uiAbsPartIdx, uiDepth );
-      }
-      else if( uiDir == DMM_WEDGE_PREDDIR_D_IDX ) 
-      { 
-        pcCU->setWedgePredDirDeltaDC1SubParts( iDC1, uiAbsPartIdx, uiDepth );
-        pcCU->setWedgePredDirDeltaDC2SubParts( iDC2, uiAbsPartIdx, uiDepth );
-      }
-      else if( uiDir == DMM_WEDGE_PREDTEX_D_IDX)  
-      { 
-        pcCU->setWedgePredTexDeltaDC1SubParts( iDC1, uiAbsPartIdx, uiDepth );
-        pcCU->setWedgePredTexDeltaDC2SubParts( iDC2, uiAbsPartIdx, uiDepth );
-      }
-      else if (uiDir== DMM_CONTOUR_PREDTEX_D_IDX )
-      {
-        pcCU->setContourPredTexDeltaDC1SubParts( iDC1, uiAbsPartIdx, uiDepth );
-        pcCU->setContourPredTexDeltaDC2SubParts( iDC2, uiAbsPartIdx, uiDepth );
-      }
-    }
-  }
-  else if (uiDir >= EDGE_INTRA_IDX)
-  {
-    m_pcTDecBinIf->decodeBin( uiSymbol, m_cEdgeIntraDeltaDCSCModel.get(0, 0, 0) );
-    if( uiSymbol )
-    {
-      uiDir = EDGE_INTRA_DELTA_IDX;
-      Int iDeltaDC = 0,iDeltaDC0 = 0,iDeltaDC1 = 0;
-      for (Int i = 0; i<2; i++)
-      {
-        xReadExGolombLevel( (UInt &) iDeltaDC, m_cEdgeIntraDeltaDCSCModel.get(0, 0, 1) );
-        if( iDeltaDC != 0 )
-        {
-          UInt uiSign;
-          m_pcTDecBinIf->decodeBinEP( uiSign );
-          if ( uiSign )
-          {
-            iDeltaDC = -iDeltaDC;
-          }
-        }
-        if ( i == 0 ) { iDeltaDC0 = iDeltaDC; }
-        else          { iDeltaDC1 = iDeltaDC; }
-      }
-
-      pcCU->setEdgeDeltaDC0( uiAbsPartIdx, iDeltaDC0 );
-      pcCU->setEdgeDeltaDC1( uiAbsPartIdx, iDeltaDC1 );
-    }
-  }
-  else if(bSdcFlag)//SDC mode
-  {
-    assert(pcCU->getPartitionSize(uiAbsPartIdx)!=SIZE_NxN);
-    pcCU->setTrIdxSubParts(0, uiAbsPartIdx, uiDepth);
-    pcCU->setCbfSubParts(1, 1, 1, uiAbsPartIdx, uiDepth);
-
-    UInt uiNumSegments = ( uiDir == DC_IDX || uiDir == PLANAR_IDX )? 1 : 2;
-    for (int uiSeg=0; uiSeg<uiNumSegments; uiSeg++)
-    {
-      parseSDCResidualData(pcCU, uiAbsPartIdx, uiDepth, uiSeg);
-    }
-  }
-
-  pcCU->setLumaIntraDirSubParts( (UChar)uiDir, uiAbsPartIdx, uiDepth );
-}
-#endif
-Void TDecSbac::parseIntraDirLumaAng  ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
-{
-  UInt uiSymbol;
-  Int  intraPredMode;
-#if PKU_QC_DEPTH_INTRA_UNI_D0195
-  if (pcCU->getSlice()->getSPS()->isDepth())
-  {
-    parseDepthModelingTable(pcCU, uiAbsPartIdx, uiDepth);
-  }
-  if (pcCU->getLumaIntraDir(uiAbsPartIdx)<NUM_INTRA_MODE && !pcCU->getSDCFlag(uiAbsPartIdx))
-  {
-#else
-#if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
-  UInt uiFlag = 0;
-  if( pcCU->getSlice()->getSPS()->getUseDMM() && (g_uiMaxCUWidth>>uiDepth) <= DMM_WEDGEMODEL_MAX_SIZE )
-  {
-    m_pcTDecBinIf->decodeBin( uiFlag, m_cDmmFlagSCModel.get(0, 0, 0) );
-  }
-  if( uiFlag )
-  {
-    UInt uiDMMode;
-
-#if HHI_DMM_WEDGE_INTRA && HHI_DMM_PRED_TEX
-    m_pcTDecBinIf->decodeBin( uiSymbol, m_cDmmModeSCModel.get(0, 0, 0) ); uiDMMode  = uiSymbol;
-    m_pcTDecBinIf->decodeBin( uiSymbol, m_cDmmModeSCModel.get(0, 0, 0) ); uiDMMode |= uiSymbol << 1;
-    if ( pcCU->getPartitionSize( uiAbsPartIdx ) != SIZE_NxN && g_uiMaxCUWidth>>uiDepth > 4 )
-    {
-      m_pcTDecBinIf->decodeBin( uiSymbol, m_cDmmModeSCModel.get(0, 0, 0) ); uiDMMode |= uiSymbol << 2;
-    }
-#else
-    m_pcTDecBinIf->decodeBin( uiSymbol, m_cDmmModeSCModel.get(0, 0, 0) ); uiDMMode  = uiSymbol;
-    if ( pcCU->getPartitionSize( uiAbsPartIdx ) != SIZE_NxN && g_uiMaxCUWidth>>uiDepth > 4 )
-    {
-      m_pcTDecBinIf->decodeBin( uiSymbol, m_cDmmModeSCModel.get(0, 0, 0) ); uiDMMode |= uiSymbol << 1;
-    }
-#endif
-    intraPredMode = uiDMMode + NUM_INTRA_MODE;
-
-#if HHI_DMM_WEDGE_INTRA
-    if( intraPredMode == DMM_WEDGE_FULL_IDX )          { xParseWedgeFullInfo          ( pcCU, uiAbsPartIdx, uiDepth ); }
-    if( intraPredMode == DMM_WEDGE_FULL_D_IDX )        { xParseWedgeFullDeltaInfo     ( pcCU, uiAbsPartIdx, uiDepth ); }
-    if( intraPredMode == DMM_WEDGE_PREDDIR_IDX )       { xParseWedgePredDirInfo       ( pcCU, uiAbsPartIdx, uiDepth ); }
-    if( intraPredMode == DMM_WEDGE_PREDDIR_D_IDX )     { xParseWedgePredDirDeltaInfo  ( pcCU, uiAbsPartIdx, uiDepth ); }
-#endif
-#if HHI_DMM_PRED_TEX
-    if( intraPredMode == DMM_WEDGE_PREDTEX_D_IDX )     { xParseWedgePredTexDeltaInfo  ( pcCU, uiAbsPartIdx, uiDepth ); }
-#if LGE_DMM3_SIMP_C0044
-    if( intraPredMode == DMM_WEDGE_PREDTEX_IDX )       { xParseWedgePredTexInfo       ( pcCU, uiAbsPartIdx, uiDepth ); }
-#endif
-    if( intraPredMode == DMM_CONTOUR_PREDTEX_D_IDX )   { xParseContourPredTexDeltaInfo( pcCU, uiAbsPartIdx, uiDepth ); }
-#endif
-  }
-  else
-  {
-#endif
-
-#if LGE_EDGE_INTRA_A0070
-    Bool bCodeEdgeIntra = false;
-    if( pcCU->getSlice()->getSPS()->isDepth() )
-    {
-      UInt uiPUWidth = pcCU->getWidth( uiAbsPartIdx ) >> (pcCU->getPartitionSize( uiAbsPartIdx ) == SIZE_NxN ? 1 : 0);
-      if( uiPUWidth <= LGE_EDGE_INTRA_MAX_SIZE && uiPUWidth >= LGE_EDGE_INTRA_MIN_SIZE )
-        bCodeEdgeIntra = true;
-    }
-#endif
-#endif
-    Int uiPreds[3] = {-1, -1, -1};
-    Int uiPredNum = pcCU->getIntraDirLumaPredictor(uiAbsPartIdx, uiPreds);  
-#if !PKU_QC_DEPTH_INTRA_UNI_D0195
-#if LGE_EDGE_INTRA_A0070
-    UInt uiCheckBit = 0;
-#endif
-#endif
-
-    m_pcTDecBinIf->decodeBin( uiSymbol, m_cCUIntraPredSCModel.get( 0, 0, 0) );
-
-    if ( uiSymbol )
-    {
-      m_pcTDecBinIf->decodeBinEP( uiSymbol );
-      if (uiSymbol)
-      {
-        m_pcTDecBinIf->decodeBinEP( uiSymbol );
-        uiSymbol++;
-      }
-      intraPredMode = uiPreds[uiSymbol];
-    }
-    else
-    {
-      intraPredMode = 0;
-
-
-      m_pcTDecBinIf->decodeBinsEP( uiSymbol, 5 );
-#if !PKU_QC_DEPTH_INTRA_UNI_D0195
-#if LGE_EDGE_INTRA_A0070
-      if (bCodeEdgeIntra)
-      {
-        if (uiSymbol==31)
-        {
-          m_pcTDecBinIf->decodeBinsEP(uiCheckBit,1);
-          if (uiCheckBit)
-            uiSymbol = EDGE_INTRA_IDX;
-        }
-      }
-#endif
-#endif
-      intraPredMode = uiSymbol;
-
-      //postponed sorting of MPMs (only in remaining branch)
-      if (uiPreds[0] > uiPreds[1])
-      { 
-        std::swap(uiPreds[0], uiPreds[1]); 
-      }
-      if (uiPreds[0] > uiPreds[2])
-      {
-        std::swap(uiPreds[0], uiPreds[2]);
-      }
-      if (uiPreds[1] > uiPreds[2])
-      {
-        std::swap(uiPreds[1], uiPreds[2]);
-      }
-#if !PKU_QC_DEPTH_INTRA_UNI_D0195
-#if LGE_EDGE_INTRA_A0070
-      if ( intraPredMode != EDGE_INTRA_IDX)
-      {
-#endif
-#endif
-        for ( Int i = 0; i < uiPredNum; i++ )
-        {
-          intraPredMode += ( intraPredMode >= uiPreds[i] );
-        }
-#if !PKU_QC_DEPTH_INTRA_UNI_D0195
-#if LGE_EDGE_INTRA_A0070
-      }
-#endif
-#endif
-    }
-
-#if !PKU_QC_DEPTH_INTRA_UNI_D0195
-#if LGE_EDGE_INTRA_A0070
-    if( intraPredMode == EDGE_INTRA_IDX )
-    {
-      xParseEdgeIntraInfo( pcCU, uiAbsPartIdx, uiDepth );
-#if LGE_EDGE_INTRA_DELTA_DC
-      m_pcTDecBinIf->decodeBin( uiSymbol, m_cEdgeIntraDeltaDCSCModel.get(0, 0, 0) );
-      if( uiSymbol )
-      {
-        intraPredMode = EDGE_INTRA_DELTA_IDX;
-        Int iDeltaDC0;
-        Int iDeltaDC1;
-
-        xReadExGolombLevel( (UInt &) iDeltaDC0, m_cEdgeIntraDeltaDCSCModel.get(0, 0, 1) );
-        if( iDeltaDC0 != 0 )
-        {
-          UInt uiSign;
-          m_pcTDecBinIf->decodeBinEP( uiSign );
-          if ( uiSign )
-          {
-            iDeltaDC0 = -iDeltaDC0;
-          }
-        }
-        xReadExGolombLevel( (UInt &) iDeltaDC1, m_cEdgeIntraDeltaDCSCModel.get(0, 0, 1) );
-        if( iDeltaDC1 != 0 )
-        {
-          UInt uiSign;
-          m_pcTDecBinIf->decodeBinEP( uiSign );
-          if ( uiSign )
-          {
-            iDeltaDC1 = -iDeltaDC1;
-          }
-        }
-
-        pcCU->setEdgeDeltaDC0( uiAbsPartIdx, iDeltaDC0 );
-        pcCU->setEdgeDeltaDC1( uiAbsPartIdx, iDeltaDC1 );
-      }
-#endif
-    }
-#endif
-
-#if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
-  }
-#endif
-  pcCU->setLumaIntraDirSubParts( (UChar)intraPredMode, uiAbsPartIdx, uiDepth );
-#else
-  pcCU->setLumaIntraDirSubParts( (UChar)intraPredMode, uiAbsPartIdx, uiDepth );
-}
-#endif
-}
-
-Void TDecSbac::parseIntraDirChroma( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
-{
-  UInt uiSymbol;
 
   m_pcTDecBinIf->decodeBin( uiSymbol, m_cCUChromaPredSCModel.get( 0, 0, 0 ) );
@@ -1317,25 +1123,17 @@
   if( uiSymbol == 0 )
   {
+#if H_MV_ENC_DEC_TRAC          
+    DTRACE_CU("intra_chroma_pred_mode", uiSymbol )
+#endif        
     uiSymbol = DM_CHROMA_IDX;
   } 
   else 
   {
-    if( pcCU->getSlice()->getSPS()->getUseLMChroma() )
-    {
-      m_pcTDecBinIf->decodeBin( uiSymbol, m_cCUChromaPredSCModel.get( 0, 0, 1 ) );
-    }
-    else
-    {
-      uiSymbol = 1;
-    }
-
-    if( uiSymbol == 0 )
-    {
-      uiSymbol = LM_CHROMA_IDX;
-    } 
-    else
     {
       UInt uiIPredMode;
       m_pcTDecBinIf->decodeBinsEP( uiIPredMode, 2 );
+#if H_MV_ENC_DEC_TRAC          
+      DTRACE_CU("intra_chroma_pred_mode", uiIPredMode )
+#endif        
       UInt uiAllowedChromaDir[ NUM_CHROMA_MODE ];
       pcCU->getAllowedChromaDir( uiAbsPartIdx, uiAllowedChromaDir );
